#!/usr/bin/perl

use Tk;

$db_dir="/home/SKan/kouji/db";

# եȤ
#option(add,"*Font",a14);
#option(add,"*kanjiFont",k14);

&main_window;

sub main_window {
    my $w = MainWindow->new;

#    $w->wm("-title"=>"MY ADDRES");

    &menu($w);

    &mk_listbox($w);

    &dataload($w,"addres.tbl");

    MainLoop;
}

sub menu {
    local($w)=shift;
    local($name,$file);
    
    open(INIT,"<$ENV{HOME}/.dbview") || die "Can not open ~/.dbview.\n";

    my $w1 = $w->Frame(-relief=>raised);
    $w1->pack("-side"=>top,"-fill"=>x);
    my $w2 = $w1->Menubutton("-text"=>"DBѹ");

    while(<INIT>) {
	chop;
	if (/^DB_HOME=(.*)/) {
	    $db_dir = $1;
	    $db_dir =~ s/~/$ENV{HOME}/;
	} else {    # ɥܥκ
	    ($name,$file) = split(/=/,$_);
	    $w2->command("-label"=>"$name",
		 "-command" => [ \&dataload,$w,"$file"]);
	}
    }
    $w2->pack("-side"=>left,"-fill"=>x);

    # λܥκ
    $w2 = $w1->Button("-text"=>"λ",-relief=>flat,"-command"=>sub {exit 0});
    $w2->pack("-side"=>left,"-fill"=>x);

}

# ǡɥ֥롼
sub dataload {
    my $w = shift;
    my $file = shift;

    %data = ();

    # եΥץ
    open(DB,"<$db_dir/$file") || die "Can not load $db_dir/$file\n";

    $data{'head'} = <DB>;

    # ǡ˳Ǽ
    while(<DB>) {
	split(/:/,$_);
	$data{$_[0]}=$_;
    }

    # եΥ
    close($DB);

    &list_up;
}

sub mk_listbox {
#  global data lbox

    my $w = shift;
    my $title,$subtitle;
    my $key,$subkey;

    my $w1 = $w->Frame;
    $w1->pack("-side"=>top);
    my $w2 = $w1->ScrlListbox("-relief"=>sunken);
    $w2->pack("-side"=>"left","-expand"=>"yes","-fill"=>"both");
    $w2->bind("<Double-1>",
	      sub {
		  my ($key) = $listw->get('active');
		  &syu($w,$key);
	      });

    $listw = $w2;

}

sub list_up {
    my $key,$value;
    my $fast,$sec,$title,$subtitle;

    $listw->delete(0,end);
    while (($key,$value) = each %data) {
	if ($key eq 'head') {next}
	($fast,$sec) = split(/:/,$value);
	$listw->insert(end=>$fast);
    }

    #ꥹȥܥåκ
    ($title,$subtitle) = split(/:/,$data{'head'});
    $listw->configure("-label"=>"$title");
}


# ܺ٥ǡɽ륵֥롼
sub syu {
    my $w = shift;
    my $youso = shift;
    my @line,@head ;
    my $i;

#   $w->destroy if Exists($w);
    my $top = $w->Toplevel;

    my $w1 = $top->Button("-text"=>"λ","-command"=>[destroy, $top]);
    $w1->pack("-side"=>bottom,"-fill"=>x);

    $w1 = $top->Frame;
    $w1->pack;

    @line = split(/:/,$data{$youso});
    @head = split(/:/,$data{'head'});

    for ($i = 0; $i < $#head; $i++) {
	$w1 = $top->Frame;
	$w1->pack(-fill=>x);
	my $w2 = $w1->Label("-text"=>"$head[$i]:","-width"=>10,-anchor=>w);
	$w2->pack(-side=>"left",-fill=>x);
	my $width = length($line[$i]);
	if ($width <= 50) {$width = 50}	
	$w2 = $w1->Label("-text"=>"$line[$i]","-width"=>$width,-anchor=>w);
	$w2->pack(-side=>"left");
    }
}

# ɴؿ
sub reload {
    my $db_file = shift;
#	global data lbox

#    .head configure -text [lindex $data(header) 0]

    &dataload($db_file);
    &list_up;
}

