#
#  Perl DataBase library Version 1.5
#
#            Program by maruya@muh.biglobe.ne.jp
#
# Ver 1.5  1997/06/03
#          * cacheǻѤDBեη$main::DB_TYPEǤ褦ˤ
# Ver 1.4  1996/05/26
#          * pdb_open,pdb_closecache_open,cache_closeѹ
# Ver 1.3  1996/05/25
#          * save_dataɲ
# Ver 1.2  1996/04/24
#          * %dbdbmեѤ롣
#          * load_all_dataؿɲ
#          * perl5Τߤбˤʤä
# Ver 1.1  1996/04/09
#          * ǡLOOP򸡽Ф뵡ǽɲ
#          * text_serchɲ
# Ver 1.0  1996/04/08

package pdblib;

use Fcntl;

%db = ();			# ǡȥϢ
$dbm_flag = 0;			# dbmOpen Mode flag(0=close;1=read open;2=write open)
$DBLD = 0;			# ǡ١եѤΥեϥɥ
@keys = ();			# %dbkey
$ERROR_MESSAGE;			# 顼åǼѿ
%load_file = ();		# ɤ߹ե̾򵭲Ƥ
%loop_check = ();		# ǡ¤Loopå٤˻Ѥ

sub cache_open {
# %dbθȤʤallǡ١ե򥪡ץ󤹤롣
#  
#   $_[0]  WRITEǤRead & Writeǥץ󤹤롣
#  
#     ̾   0
#     顼 1

    # 顼å򥯥ꥢ롣
    $ERROR_MESSAGE="";

    if ($main::DB_DIR eq "") {
	$ERROR_MESSAGE = "cache_open:\$DB_DIRꤵƤޤ";
	return 1;
    }


    if ($main::DB_TYPE eq "GDBM") { # GDBMѤ롣
	if ($_[0] eq "WRITE") {
	    use GDBM_File;
	    $dbm_flag = 2;
	    tie(%db, NDBM_File, "$main::DB_DIR/all" , &GDBM_WRCREAT , 0640);
	} else {
	    $dbm_flag = 1;
	    tie(%db, NDBM_File, "$main::DB_DIR/all" , &GDBM_READER , 0640 );
	}
    } elsif ($main::DB_TYPE eq "NDBM") { # NDBMѤ롣
	use NDBM_File;
	if ($_[0] eq "WRITE") {
	    $dbm_flag = 2;
	    tie(%db, NDBM_File, "$main::DB_DIR/all.dbmx" , O_RDWR|O_CREAT, 0640);
	} else {
	    $dbm_flag = 1;
	    tie(%db, NDBM_File, "$main::DB_DIR/all.dbmx" , O_RDONLY, 0640 );
	}
    } else {			# DBѤ롣
	use DB_File;
	if ($_[0] eq "WRITE") {
	    $dbm_flag = 2;
	    tie(%db, DB_File, "$main::DB_DIR/all.dbmx" , O_RDWR|O_CREAT, 0640 , $DB_HASH );
	} else {
	    $dbm_flag = 1;
	    tie(%db, DB_File, "$main::DB_DIR/all.dbmx" , O_RDONLY, 0640 , $DB_HASH );
	}
    }

    return 0;
}

sub cache_close {
# %dbθȤʤallǡ١ե򥯥롣
#  
#     ʤ

    # 顼å򥯥ꥢ롣
    $ERROR_MESSAGE="";

    $dbm_flag = 0;
    untie(%db);
}

sub save_data {
# Υǡե˥֤롣
# 
#  $_[0]    ե̾
#  $_[1..n] ֤ǡ (:ǡ)
# 
#     ̾   0
#     顼 1

    local($file_name) = shift(@_);
    local(@save_data) = @_;
    local($flag_backup);

    $LOCK_SH = 1;
    $LOCK_EX = 2;
    $LOCK_NB = 4;
    $LOCK_UN = 8;

    # ե˥֤롣
    if (!open(DBSV,">$main::DB_DIR/$file_name.dat")) {
	$ERROR_MESSAGE = "save_data:$main::DB_DIR/$file_name.datץޤ";
	return 1;
    }

    # åݤ롣
    flock(DBSV,$LOCK_EX);

    foreach $line (@save_data) {
	print DBSV "$line\n";
    }

    # å롣
    flock(DBSV,$LOCK_UN);

    close(DBSV);

    load_data("\@$file_name");
}

sub load_all_data {
# $DB_DIRǡɤ߹
#  
#     ̾   0
#     顼 1

    return load_all_data_sub($main::DB_DIR);

}

sub load_all_data_sub {
# load_all_dataμºݤν򤹤ؿ
# ƵƤӽФ롣
#  @[0]     ǥ쥯ȥ
#  
#     ̾   0
#     顼 1

    local($dir) = shift(@_);
    local($file,$db_object);
    local(@file_list);

    # 顼å򥯥ꥢ롣
    $ERROR_MESSAGE="";

    if (!opendir(DIR,$dir)) {
	$ERROR_MESSAGE = "load_all_data:$dirץǤޤ";
	return 1;
    }

    @file_list = readdir(DIR);

    closedir(DIR);

    foreach $file (@file_list) {
	if ($file =~ /^\./) {next;}
	if ($file =~ /^all/) {next;}
	if ( -d "$dir/$file" ) {
	    &load_all_data_sub("$dir/$file");
	}
	if ( -f "$dir/$file" ) {
	    if (! $file =~ /.dat$/) {next;}
	    $db_object = "$dir/$file";
	    $db_object =~ s/$main::DB_DIR\///g;
	    $db_object =~ s/.dat$//g;
	    &load_data("\@$db_object");
	}
    }
    return 0;
}

sub load_data {
# ǡե뤫ǡɤ߹ࡣ
#  @[0]     ե̾
#  
#     ̾   0
#     顼 1

    # 顼å򥯥ꥢ롣
    $ERROR_MESSAGE = "";

    if ($main::DB_DIR eq "") {
	$ERROR_MESSAGE = "load_data:\$DB_DIRꤵƤޤ";
	return 1;	
    }

    # Υå
    if ($#_ <  0 ) {
	$ERROR_MESSAGE = "load_data:­ޤ";
	return 1;
    }

    $DBLD = 0;
    %loop_check = ();

    return &load_data_sub($_[0]);

}

sub load_data_sub {
# load_dataμºݤν򤹤ؿ
# ƵƤӽФ롣
#  @[0]     ե̾
#  
#     ̾   0
#     顼 1

    local($file_name) = shift(@_);
    local($tag)=$file_name;
    local($key,$value,$link);

    $file_name =~ tr/A-Z/a-z/;
    $file_name =~ s/^@//g;
    $tag       =~ tr/a-z/A-Z/;

    # LOOPƤʤå롣
    if (defined($loop_check{$file_name})) {
	$ERROR_MESSAGE = "load_data:ǡLOOPƤޤ";
	return 1;
    } else {
	$loop_check{$file_name} = "";
    }

    # ɤ߹ߺѤߥեǤ뤫å롣
    if (defined($load_file{$file_name})) {
	return 0;
    } else {
	$load_file{$file_name} = "";
    }

    $DBLD++;
    # ǡե륪ץ
    if (!open($DBLD,"<$main::DB_DIR/$file_name.dat")) {
	$ERROR_MESSAGE = "load_data:$main::DB_DIR/$file_name.datץޤ";
	return 1;
    }

    # ǡɤ߼롼
    while(<$DBLD>) {
	chop;
	$_ = &space_delete($_);	# ڡκ

	/^([^:]*):(.*)/ && do {
	    $key = $1;
	    $key =~ tr/a-z/A-Z/;
	    $value = &space_delete($2);
	    if ( $value =~ /^\@(.*)/ ) { # ֥ǡ
		# linkط¸롣
		$link = $1;
		$link =~ tr/a-z/A-Z/;
		# ƵƤӽФ
		if ( &load_data_sub("\@$link") ) {
		    return 1;
		}
		$value =~ tr/a-z/A-Z/;
		$db{"$tag.$key"}=$value;
	    } else {
		$db{"$tag.$key"}=$value;
	    }
	};
    }

    # ǡ١
    close(DB_FILE);

    $DBLD--;
    return 0;
}

sub space_delete {
# ϤȽΥڡ롣
#  @[0]    оݤʸ
# 
#   ڡʸ

    local($str) = shift(@_);

    $str =~ s/^\s+//;		# ǽΥڡ
    $str =~ s/^()+//;		# ǽʸʸ
    $str =~ s/\s+$//;		# ǸΥڡ
    $str =~ s/()+$//;		# Ǹʸʸ

    return $str;
}

sub get_data {
# ǡФ
#  $_[0] 
#  
#     бǡ
#  顼
#      Nullʸ֤롣

    # 顼å򥯥ꥢ롣
    $ERROR_MESSAGE = "";

    # Υå
    if ( @_ eq  () ) {
	$ERROR_MESSAGE = "get_data:­ޤ";
	return "";
    }

    local($key) = shift(@_);
    local($i,$serch_key);

    $serch_key = "";

    foreach $i (split(/\./,$key)) {
	$serch_key = $serch_key . $i; 
	if (defined($db{$serch_key})) {
	    if ( $db{$serch_key} =~ /^\@/ ) { # ֥ǡ롣
		$key =~ s/$serch_key/$db{$serch_key}/;
		return &get_data($key);
	    } else {
		if ($key eq $serch_key) {     # Keyޥå
		    return $db{$serch_key};
		} else {
		    last;                     # ̵KeyꤵƤ롣
		}
	    }
	}
	$serch_key = $serch_key . ".";
    }
    $ERROR_MESSAGE = "Key˥ޥåǡޤ";
    return "";
}

sub select_key {
# 򸡺롣
#  $_[0] 
#  
#    ޥåäƤkey

    # 顼å򥯥ꥢ롣
    $ERROR_MESSAGE = "";

    # Υå
    if ( @_ eq () ) {
	$ERROR_MESSAGE = "select_key:­ޤ";
	return;
    }

    local($keyword) = shift(@_);
    
    @keys = keys(%db);
    @match_key = ();

    return &select_key_sub("",@keys);
}

sub select_key_sub {
# select_keyμºݤνԤʤؿ
# ƵƤӽФ롣
#  $_[0]    
#  $_[1..n] оݤȤʤ%dbkey
#  
#    ޥåäƤkey

    local($path) = shift(@_);
    local(@match_keys) = ();
    local($key,$key2);

    foreach $key (@_) {
	$key2 = $key;
	if ($path ne "") {
	    $key2 =~ s/([^\.]*)/$path/;
	}
	if ($db{$key} =~ /^(@.*)/) {
	    push(match_keys,&select_key_sub($key2,grep(/^$1/,@keys)));
	} elsif ($key2 =~ /$keyword/) {
	    push(match_keys,$key2);
	}
    }
    return @match_keys;
}

sub select_value {
# ǡ򸡺롣
# ƵƤӽФ롣
#  $_[0]    
#  $_[1..n] 륭
#  
#    ޥåǡäƤkey

    # 顼å򥯥ꥢ롣
    $ERROR_MESSAGE = "";

    # Υå
    if ( $#_ < 1 ) {
	$ERROR_MESSAGE = "select_value:­ޤ";
	return;
    }

    local($keyword) = shift(@_);
    local($key,$value);
    local(@match_keys) = ();

    foreach $key (@_) {
	$value = &get_data($key);
	if ($value =~/$keyword/) {
	    push(@match_keys,$key);
	}
    }
    return @match_keys;
}

sub select_value2 {
# ǡ򸡺롣ǡե⸡롣
# ƵƤӽФ롣
#  $_[0]    
#  $_[1..n] 륭
#  
#    ޥåǡäƤkey

    # 顼å򥯥ꥢ롣
    $ERROR_MESSAGE = "";

    # Υå
    if ( $#_ < 1 ) {
	$ERROR_MESSAGE = "select_value2:­ޤ";
	return ();
    }

    local($keyword) = shift(@_);
    local($key,$value);
    local(@match_keys) = ();

    foreach $key (@_) {
	$value = &get_data($key);
	if ($value =~ /^#(.*)/) {
	    if (&text_serch($keyword,$1)) {
		push(@match_keys,$key);
	    } else {
		if ($ERROR_MESSAGE ne "") {
#		    print "$ERROR_MESSAGE\n";
		}
	    }
	}
	if ($value =~ /$keyword/) {
	    push(@match_keys,$key);
	}
    }
    return @match_keys;
}

sub text_serch {
# եƥȥؿ
#  $_[0] 
#  $_[1] ե̾
#  
#    ޥå        1
#    ޥåʤä  0

    # 顼å򥯥ꥢ롣
    $ERROR_MESSAGE = "";

    local($keyword) = shift(@_);
    local($file_name) = shift(@_);

    if (!open(TEXT_SERCH,"<$main::DB_DIR/$file_name")) {
	$ERROR_MESSAGE = "text_serch:$main::DB_DIR/$file_name.datץޤ";
	return 0;
    }

    while(<TEXT_SERCH>) {
	if (/$keyword/) {
	    close(<TEXT_SERCH>);
	    return 1;
	}
    }

    close(<TEXT_SERCH>);
    return 0;
}

sub change_key {
# ǽʬѹ롣
# 
#  $_[0]  
#  $_[1]  񤭴ʸ
# 
#  񤭴줿

    local($key) = shift(@_);
    local($new_key) = shift(@_);

    $key =~ s/[^.]*$/$new_key/;

    return $key;
}

1;
